# -*- coding:Utf-8 -*-

import es
import os
from socket import *
import threading
import gamethread
import popuplib
import playerlib
from configobj import ConfigObj
from random import Random
from redirectlib import Redirect
from colormsglib import ColorMsg
import psyco
psyco.full()
from es import server_var


info = es.AddonInfo()
info.name = "redirection"
info.version = "2.3"
info.author = "EmbouT"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?t=24216"
info.description = "Redirects a player on another server (password supported)"

es.ServerVar(info.name,info.version,'public var').makepublic()
saycmd=es.ServerVar('redirection_saycmd')
menukick=es.ServerVar('redirection_menukick')
maxplayers=es.ServerVar('redirection_maxplayers')
reserveslot=es.ServerVar('redirection_exclude_admins')
hazard=es.ServerVar('redirection_random')
sendmenu=es.ServerVar('redirection_sendmenu')
forceredirect=es.ServerVar('redirection_forceredirect')
kick=es.ServerVar('redirection_kick')
temps=es.ServerVar('redirection_time')
menuselect=es.ServerVar('redirection_menuselect')
admin=server_var.getObject('BASIC_AUTH_ADMIN_LIST')


servergroup={}
plist=[]

lang={}
lang_default={'prev': 'Previous page','next': 'Next page','last':'Last page','first':'1st Page','quit': 'Quit',
    'title':'Choose a server','page':'Page','noserver':'There is no server redirection',
    'admin arrive':'An admin has arrived','give place':'You have to give him your place!',
    'admin only':'There is that admins on the server', 'server full':'The server is full !!'}



def load():
    global lang,lang_default
    path = es.getAddonPath('redirection') + '/redirection_languages.ini'
    if os.path.isfile(path):
        contructLangDict(ConfigObj(path))
    else:
        es.dbgmsg(0,'[redirection] Unable to load redirection_languages.ini! Please ensure it is in the ../redirection/ directory.')
    if not lang:
        lang['en']=lang_default
    if not es.exists('command','serveradd'):
        es.regcmd('serveradd','redirection/serveradd_cmd',' Console command to add server. Syntax : serveradd <"ip:port"> ["server password"]')
    es.mexec('../addons/eventscripts/redirection/redirection.cfg')
    gamethread.delayed(0.2,createcmd_say)
    gamethread.delayedname(0.5,'redirection_updatemenu',get_serverinfo)

def contructLangDict(obj):
    global lang,lang_default
    for key in obj:
        if lang_default.has_key(key):
            for l in obj[key]:
                if not lang.has_key(l):lang[l]={}
                lang[l][key]=obj[key][l]
    for l in lang:
        for default_item in lang_default:
            if not lang[l].has_key(default_item):
                lang[l][default_item]=lang_default[default_item]

def createcmd_say():
    if not str(saycmd) == '0':
        if not es.exists('saycommand',str(saycmd)):
            es.regsaycmd(str(saycmd),'redirection/say_cmd',"Custom say command to display servers's menu")

def serveradd_cmd():
    def testip(h):
        try:
            i=h.split(":")
            int(i[1])
            for x in i[0].split("."):
                t=int(x)
        except: return False
        return True
    argc=es.getargc()
    if argc in (2,3):
        server=es.getargv(1)
        password=''
        if argc==3:
            password=es.getargv(2)
            if password=='0':password=''
        if testip(server):
            servergroup[len(servergroup)]={'server':server,'password':password,'name':'','place':(0,0),'dispo':[0,0]}
            if not str(saycmd)=='0' or not str(sendmenu)=='0':
                createmenu()
        else:
            es.dbgmsg(0,'[redirection] %s is an invalid IP adress!'%server)
    else:
        es.dbgmsg(0,'[redirection] Syntax Error !')
        es.dbgmsg(0,'[redirection] Syntax : serveradd <ip:port> ["server password"]')

def say_cmd():
    userid=es.getcmduserid()
    l=playerlib.getPlayer(userid).get('lang')
    if not l in lang:l='en'
    if servergroup:
        get_serverinfo()
        popuplib.send('%s_redirection_server_menu_page_1'%l,userid)
        es.playsound(userid,"buttons/combine_button7.wav", 1.0)
    else:
        ColorMsg("#green[redirection]#red "+lang[l]['noserver']).tell(userid)

def createmenu():
    menu={}
    for l in lang:
        spp=0
        spc=0
        m=0
        menu[l]={}
        for s in servergroup:
            if spp==5:spp=0
            if spp==0:
                spc+=1
                if spc>1:
                    menu[l][m].addline('-------------------------------')
                    menu[l][m].addline('->8. '+lang[l]['prev'])
                    menu[l][m].addline('->9. '+lang[l]['next'])
                    menu[l][m].addline('0. '+lang[l]['quit'])
                    spc-=2
                    menu[l][m].submenu(8,'%s_redirection_server_menu_page_%i'%(l,spc))
                    spc+=2
                    menu[l][m].submenu(9,'%s_redirection_server_menu_page_%i'%(l,spc))
                    menu[l][m].enablekeys=mek+'89'
                    menu[l][m].menuselect=menu_select
                if popuplib.exists('%s_redirection_server_menu_page_%i'%(l,spc)):popuplib.delete('%s_redirection_server_menu_page_%i'%(l,spc))
                m+=1
                mek='0'
                menu[l][m]=popuplib.create('%s_redirection_server_menu_page_%i'%(l,spc))
                menu[l][m].addline(lang[l]['title'])
                menu[l][m].addline('-------------------------------')
            spp+=1
            mek+=str(spp)
            servergroup[s]['place']=(spc,spp+2)
            menu[l][m].addline('->%i. %s (%i/%i)'%(servergroup[s]['place'][1]-2,servergroup[s]['name'],servergroup[s]['dispo'][0],servergroup[s]['dispo'][1]))
            menu[l][m].menuvalue('redirection_menuselect',spp,s)


        if spc>1:
            menu[l][m].addline('-------------------------------')
            menu[l][m].addline('->8. '+lang[l]['prev'])
            menu[l][m].addline('->9. '+lang[l]['first'])
            menu[l][m].addline('0. '+lang[l]['quit'])
            spc-=1
            menu[l][m].submenu(8,'%s_redirection_server_menu_page_%i'%(l,spc))
            spc+=1
            menu[l][m].submenu(9,'%s_redirection_server_menu_page_1'%l)
            menu[l][m].enablekeys=mek+'89'
            menu[l][m].menuselect=menu_select
            menu[l][1].modline(9,'->8. '+lang[l]['last'])
            menu[l][1].submenu(8,'%s_redirection_server_menu_page_%i'%(l,spc))
            i=1
            while i <= spc:
                menu[l][i].modline(1,lang[l]['title']+' : '+lang[l]['page']+'%i/%i'%(i,spc))
                i+=1
        elif spc==1:
            menu[l][1].addline('-------------------------------')
            menu[l][1].addline('0. '+lang[l]['quit'])
            menu[l][1].enablekeys=mek
            menu[l][1].menuselect=menu_select

def menu_select(userid,choix,menuname):
    if choix<10:
        es.playsound(userid,"buttons/button14.wav", 1.0)
        if choix<6:
            redirectplayer(userid,int(menuselect),1)
            gamethread.cancelDelayed('redirectionforce%s'%userid)
    else:
        es.playsound(userid,"buttons/combine_button7.wav", 1.0)

def redirectplayer(userid,s,m=0):
    k=int(kick)
    if m:k=int(menukick)
    Redirect(servergroup[s]['server'],servergroup[s]['password'],k,float(temps)).send(userid)


def redirectforce(userid):
    p=popuplib.active(userid)
    if p['name']:
        popuplib.close(p['name'],userid)
        redirectplayer(userid,Random().randint(0,len(servergroup)-1)if int(hazard) else 0)

def player_activate(event_var):
    if servergroup:
        userid=event_var['userid']
        l=playerlib.getPlayer(userid).get('lang')
        if not l in lang:l='en'
        if maxplayers<es.getplayercount():
            a=0
            if int(reserveslot):
                if event_var['es_steamid']in str(admin).split(';'):
                    lastplayer=foundlastplayer(userid)
                    a=1 if lastplayer == userid else 2
                    userid=lastplayer
            if int(sendmenu):
                popuplib.send('%s_redirection_server_menu_page_1'%l,userid)
                gamethread.delayedname(int(forceredirect),'redirectionforce%s'%userid,redirectforce,userid)
            else:
                redirectplayer(userid,Random().randint(0,len(servergroup)-1)if int(hazard) else 0)
            if a==2:
                ColorMsg("#green[redirection] #blue%s"%lang[l]['admin arrive']).tell(userid)
                ColorMsg("#green[redirection] #red%s"%lang[l]['give place']).tell(userid)
            elif a==1:
                ColorMsg("#green[redirection]#lightgreen%s"%lang[l]['admin only']).tell(userid)
            else:
                ColorMsg("#green[redirection]#lightgreen%s"%lang[l]['server full']).tell(userid)
        elif int(reserveslot):
            if not event_var['es_steamid']in str(admin).split(';'):
                plist.append(userid)

def foundlastplayer(user):
    if plist:
        userid=plist.pop()
        if not es.exists('userid',userid):
            foundlastplayer(user)
        else: return userid
    else:return user

def infoserveur(s):
    def getdata(data):
        x={}
        x['hostname'] = getstr(data)
        data=data[len(x['hostname'])+1:]
        x['map']=getstr(data)
        data=data[len(x['map'])+1:]
        x['dossier']=getstr(data)
        data=data[len(x['dossier'])+1:]
        x['description']=getstr(data)
        data=data[len(x['description'])+3:]
        x['player']=ord(data[0])
        x['players']=ord(data[1])
        return x
    def getstr(data):
        x=''
        for c in range(len(data)):
            d=str(data[c])
            if d!='\x00':x=x+d
            else:break
        return x
    host=servergroup[s]['server'].split(':')
    serversock = socket(AF_INET, SOCK_DGRAM)
    serversock.connect((host[0],int(host[1])))
    serversock.send('\xFF\xFF\xFF\xFF\x54\x53\x6F\x75\x72\x63\x65\x20\x45\x6E\x67\x69\x6E\x65\x20\x51\x75\x65\x72\x79\x00')
    info=getdata(serversock.recv(1400)[6:])
    serversock.close()
    servergroup[s]['name']=info['hostname']
    servergroup[s]['dispo']=(info['player'],info['players'])

def updatemenu():
    if not str(saycmd)=='0' or not str(sendmenu)=='0':
        for s in servergroup:
            infoserveur(s)
            for l in lang:
                m=popuplib.find('%s_redirection_server_menu_page_%i'%(l,servergroup[s]['place'][0]))
                m.modline(servergroup[s]['place'][1],'->%i. %s (%i/%i)'%(servergroup[s]['place'][1]-2,servergroup[s]['name'],servergroup[s]['dispo'][0],servergroup[s]['dispo'][1]))
                m.update(es.getUseridList())

def get_serverinfo():
    getserverinfo=threading.Thread(target=updatemenu)
    getserverinfo.start()

def player_disconnect(event_var):
    if servergroup:
        if event_var['userid'] in plist:
            plist.remove(event_var['userid'])
        gamethread.cancelDelayed('redirectionforce%s'%event_var['userid'])

def unload():
    gamethread.cancelDelayed('redirection_updatemenu')
    if es.exists('saycommand',str(saycmd)):
        es.unregsaycmd(str(saycmd))
    for l in lang:
        i=1
        while i > 0:
            if popuplib.exists('%s_redirection_server_menu_page_%i'%(l,i)):
                popuplib.delete('%s_redirection_server_menu_page_%i'%(l,i))
                i+=1
            else : i=0


